#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

bool is_possible(ll n, ll d, const vector<pair<ll, ll>>& intervals) {
    ll last_pos = -d - 1;

    for (auto [a, b] : intervals) {
        ll first_pos = max(a, last_pos + d);

        if (first_pos > b) {
            continue;
        }

        ll count = (b - first_pos + d) / d;

        n -= count;
        last_pos = first_pos + (count - 1) * d;

        if (n <= 0) {
            return true;
        }
    }

    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<pair<ll, ll>> intervals(m);

    for (auto& interval : intervals) {
        cin >> interval.first >> interval.second;
    }

    sort(intervals.begin(), intervals.end(), [&](const auto& a, const auto& b) {
        return a.first < b.first;
    });

    ll low = 1;
    ll high = 1000000000000000007;

    while (low < high - 1) {
        ll middle = (low + high) / 2;
        // cout << low << " " << high << " " << middle << endl;
        
        if (is_possible(n, middle, intervals)) {
            low = middle;
        } else {
            high = middle;
        }
    }

    cout << low << "\n";

    return 0;
}
