#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

const int mod = 1000000007;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    if (n <= 1) {
        cout << "1\n";
        return 0;
    }

    vector<int> max_hunger(n);

    for (auto& value : max_hunger) {
        cin >> value;
    }

    vector<vector<int>> dp(n, vector<int>(1001, 0));

    auto solve = [&]() {
        for (auto& row : dp) {
            row.assign(1001, 0);
        }

        for (int j = 0; j <= max_hunger[0]; j++) {
            dp[0][j] = 1;
            // cout << "dp[" << 0 << "][" << j << "] = " << dp[0][j] << "\n";
        }

        for (int j = 0; j <= min(max_hunger[1], max_hunger[0]); j++) {
            dp[1][j] = 1;
            // cout << "dp[" << 1 << "][" << j << "] = " << dp[1][j] << "\n";
        }

        for (int i = 2; i < n; i++) {
            for (int j = 0; j <= max_hunger[i]; j++) {
                for (int k = 0; k <= max_hunger[i - 1] - j; k++) {
                    dp[i][j] += dp[i - 1][k];
                    dp[i][j] %= mod;
                }

                // cout << "dp[" << i << "][" << j << "] = " << dp[i][j] << "\n";
            }
        }

        int result = 0;

        for (int j = 0; j <= max_hunger[n - 1]; j++) {
            result += dp[n - 1][j];
            result %= mod;
        }

        return result;
    };

    // if (n % 2 == 1) {
    //     // for (int j = 0; j <= max_hunger[n - 1]; j++) {
    //     //     for (int constant = 0; constant <= j; constant++) {
    //     //         for (int k = 0; k + j <= max_hunger[n - 2]; k++) {
    //     //             dp[n - 1][j] += dp[n - 2][k + constant];
    //     //             dp[n - 1][j] %= mod;
    //     //         }
    //     //         cout << "dp[" << n - 1 << "][" << j << "] = " << dp[n - 1][j] << "\n";
    //     //     }
    //     // }

    //     for (int k = 0; k <= max_hunger[n - 2]; k++) {
    //         for (int j = 0; j <= min(max_hunger[n - 1], max_hunger[n - 2] - k); j++) {
    //             dp[n - 1][j] += dp[n - 2][k] * (max_hunger[n - 1] - j + 1);
    //             dp[n - 1][j] %= mod;
    //             // cout << "dp[" << n - 1 << "][" << j << "] = " << dp[n - 1][j] << "\n";
    //         }
    //     }
    // }

    // cout << result << "\n";

    if (n % 2 == 0) {
        cout << solve() << "\n";
    } else {
        int result = 0;

        while (true) {
            result += solve();
            result %= mod;

            bool abort = false;

            for (int i = 0; i < n; i++) {
                max_hunger[i] -= 1;

                if (max_hunger[i] < 0) {
                    abort = true;
                    break;
                }
            }

            if (abort) {
                break;
            }
        }

        cout << result << "\n";
    }

    return 0;
}
