#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

const int mod = 1000000007;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    if (n <= 1) {
        cout << "1\n";
        return 0;
    }

    vector<int> max_hunger(n);

    for (auto& value : max_hunger) {
        cin >> value;
    }

    vector<vector<vector<int>>> dp(1001, vector(2, vector<int>(1001, 0)));

    for (int cap = 1000; cap >= 0; cap--) {
        for (int j = 0; j <= max_hunger[0] - cap; j++) {
            dp[cap][0][j] = 1;
        }

        for (int j = 0; j <= min(max_hunger[1], max_hunger[0]) - cap; j++) {
            dp[cap][1][j] = 1;
        }

        for (int i = 2; i < n; i++) {
            int k = 0;
            int k_sum = 0;

            for (int j = max_hunger[i] - cap; j >= 0; j--) {
                for (; k <= max_hunger[i - 1] - cap - j; k++) {
                    k_sum += dp[cap][(i + 1) % 2][k];
                    k_sum %= mod;
                }

                dp[cap][i % 2][j] = k_sum;
            }
        }
    }

    if (n % 2 == 0) {
        int result = 0;

        for (int j = 0; j <= max_hunger[n - 1]; j++) {
            result += dp[0][(n + 1) % 2][j];
            result %= mod;
        }

        cout << result << "\n";
    } else if (n % 2 == 1) {
        int result = 0;

        for (int cap = 0; cap <= 1000; cap++) {
            for (int j = 0; j <= max_hunger[n - 1] - cap; j++) {
                result += dp[cap][(n + 1) % 2][j];
                result %= mod;
            }
        }

        cout << result << "\n";
    }

    return 0;
}