#include <bits/stdc++.h>
using namespace std;

const int DIM = 2e5;
int cows[DIM], tree[DIM * 4]{0};
int q_cows;
map<int,int> last;

void input_cows(){
    for (int i = 0; i < q_cows; ++i)
        cin >> cows[i];
}

void build(int v, int t_l, int t_r){
    if (t_l == t_r) {
        tree[v] = cows[t_l];
        return;
    }

    int t_m = (t_l + t_r) >> 1;
    build(2 * v + 1, t_l, t_m);
    build(2 * v + 2, t_m + 1, t_r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int t_l, int t_r, int pos, int val){
    if (t_l > pos || t_r < pos) return;
    if (t_l == t_r) {
        tree[v] = val;
        return;
    }

    int t_m = (t_l + t_r) / 2;
    update(2 * v + 1, t_l, t_m, pos, val);
    update(2 * v + 2, t_m + 1, t_r, pos, val);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int segm_sum(int v, int t_l, int t_r, int L, int R){
    if (t_l > R || t_r < L) return 0;
    if (t_l >= L && t_r <= R) return tree[v];

    int t_m = (t_l + t_r) / 2;
    int left_s = segm_sum(2 * v + 1, t_l, t_m, L, R);
    int right_s = segm_sum(2 * v + 2, t_m + 1, t_r, L, R);
    return left_s + right_s;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> q_cows; input_cows();

    long long q_variants = 0;
    for (int i = 0; i < q_cows; ++i){
        if (last.find(cows[i]) == last.end()){
            q_variants += segm_sum(0, 0, q_cows-1, 0, i-1);
            update(0, 0, q_cows-1, i, 1);
            last[cows[i]] = i;
        }
        else {
            q_variants += segm_sum(0, 0, q_cows-1, last[cows[i]] + 1, i-1);
            update(0, 0, q_cows-1, i, 1);
            update(0, 0, q_cows-1, last[cows[i]], 0);
            last[cows[i]] = i;
        }
    }
    
    cout << q_variants << '\n';
    
    return 0;
}
