#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

vector<lli> v;
vector<lli> c;

map<lli, lli> mp;

struct SIGMAK_TREE
{
    vector<vector<lli>> t;
    lli n;

    void build(lli a, lli l, lli r) {
        if (l == r) {
            t[a].push_back(c[l]);
            return;
        }
        lli m = (l + r) >> 1;
        build(a * 2 + 1, l, m);
        build(a * 2 + 2, m+1, r);
        t[a] = t[a * 2 + 1];
        for (auto to : t[a * 2 + 2])t[a].push_back(to);
        sort(t[a].begin(), t[a].end());
    }

    void init(lli nn) {
        n = nn;
        t.resize(4 * n);
        build(0, 1, n);
    }

    lli get(lli a, lli tl, lli tr, lli l, lli r, lli val) {
        if (tl > r || tr < l)return 0;
        if (tl >= l && tr <= r) {
            lli curr = upper_bound(t[a].begin(), t[a].end(), val)-t[a].begin();
            curr = t[a].size() - curr;
            return curr;
        }
        lli tm = (tl + tr) >> 1;
        return get(a * 2 + 1, tl, tm, l, r, val) + get(a * 2 + 2, tm+1, tr, l, r, val);
    }

    lli get_range(lli l, lli r, lli val) {
        if (r < l)return 0;
        return get(0, 1, n, l, r, val);
    }

}st;

void solve()
{
    lli n;
    cin >> n;
    v.resize(n + 1);
    c.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> v[i];
    for (int i = n; i >= 1; i--) {
        c[i] = mp[v[i]];
        if (c[i] == 0)c[i] = n + 1;
        mp[v[i]] = i;
    }
    lli ans = 0;
    mp.clear();
    st.init(n);
    for (int i = 1; i <= n; i++) {
        ans += st.get_range(mp[v[i]] + 1, i - 1, i);
        mp[v[i]] = i;
    }
    cout << ans;

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 


    solve();
}

