#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

const lli INF = 1e9;

vector<lli> v;
vector<lli> dp;

struct SIGMAK_TREE
{
    vector<lli> t;
    vector<multiset<lli>> ts;
    lli n;
    lli shift;

    void init(lli nn) {
        shift = nn;
        n = 2 * nn;
        t.resize(4 * n,INF);
        ts.resize(n+1);
        for (int i = 0; i <= n; i++)ts[i].insert(INF);
    }

    void add(lli a, lli l, lli r, lli ind, lli val) {
        if (r<ind || l>ind)return;
        if (l == r) {
            ts[l].insert(val);
            t[a] = *ts[l].begin();
            return;
        }
        lli m = (l + r) >> 1;
        add(a * 2 + 1, l, m, ind, val);
        add(a * 2 + 2, m+1, r, ind, val);
        t[a] = min(t[a * 2 + 1], t[a * 2 + 2]);
    }

    void add_el(lli ind, lli val) {
        ind += shift;
        add(0, 1, n, ind, val);
    }


    void del(lli a, lli l, lli r, lli ind, lli val) {
        if (r<ind || l>ind)return;
        if (l == r) {
            ts[l].erase(ts[l].find(val));
            t[a] = *ts[l].begin();
            return;
        }
        lli m = (l + r) >> 1;
        del(a * 2 + 1, l, m, ind, val);
        del(a * 2 + 2, m + 1, r, ind, val);
        t[a] = min(t[a * 2 + 1], t[a * 2 + 2]);
    }

    void del_el(lli ind, lli val) {
        ind += shift;
        del(0, 1, n, ind, val);
    }

    lli get(lli a, lli tl, lli tr, lli l, lli r) {
        if (tl > r || tr < l)return INF;
        if (tl >= l && tr <= r)return t[a];
        lli tm = (tl + tr) >> 1;
        return min(get(a * 2 + 1, tl, tm, l, r), get(a * 2 + 2, tm + 1, tr, l, r));
    }

    lli get_range(lli l, lli r) {
        l += shift;
        r += shift;
        return get(0, 1, n, l, r);
    }
}st;

vector<lli> p;

void solve()
{
    lli n, k;
    cin >> n >> k;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        char c;
        cin >> c;
        if (c == 'H')v[i] = 1;
        else v[i] = -1;
    }
    dp.resize(n + 1,INF);
    dp[0] = 0;
    st.init(n + 2);
    st.add_el(0, 0);
    p.resize(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        p[i] = p[i-1]+v[i];
        lli l = max(0LL, i - k + 1);
        if (l >1) st.del_el(p[l-2],dp[l-2]);
        dp[i] = min(dp[i], st.get_range(-n, p[i] - 1));
        dp[i] = min(dp[i], st.get_range(p[i], n)+1);
        st.add_el(p[i], dp[i]);
    }
    cout << dp[n];
    
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

